configuracao([[_,_,_,_,_],
              [_,_,_,_,_],
              [_,_,_,_,_],
              [_,_,_,_,_],
              [_,_,_,_,_]]).

valor(cor,          [X,_,_,_,_],X).
valor(nacionalidade,[_,X,_,_,_],X).
valor(bebida,       [_,_,X,_,_],X).
valor(cigarro,      [_,_,_,X,_],X).
valor(animal,       [_,_,_,_,X],X).

regra(1,Configuracao) :-	% O ingles vive na casa vermelha
	member(Casa,Configuracao),
	valor(nacionalidade,Casa,ingles),
	valor(cor,Casa,vermelha).
regra(2,Configuracao) :-	% O sueco tem cachorros como animais de estimacao
	member(Casa,Configuracao),
	valor(nacionalidade,Casa,sueco),
	valor(animal,Casa,cachorros).
regra(3,Configuracao) :-	% O dinamarques bebe cha
	member(Casa,Configuracao),
	valor(nacionalidade,Casa,dinamarques),
	valor(bebida,Casa,cha).
regra(4,Configuracao) :-	% A casa verde fica do lado esquerdo da casa branca
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(cor,CasaX,verde),
	valor(cor,CasaY,branca).
regra(5,Configuracao) :-	% O homem que vive na casa verde bebe cafe
	member(Casa,Configuracao),
	valor(cor,Casa,verde),
	valor(bebida,Casa,cafe).
regra(6,Configuracao) :-	% Quem fuma Pall Mall cria passaros
	member(Casa,Configuracao),
	valor(cigarro,Casa,pall_mall),
	valor(animal,Casa,passaros).
regra(7,Configuracao) :-	% O homem que vive na casa amarela fuma Dunhill
	member(Casa,Configuracao),
	valor(cor,Casa,amarela),
	valor(cigarro,Casa,dunhill).
regra(8,Configuracao) :-	% O homem que vive na casa do centro bebe leite
	Configuracao = [_,_,Casa,_,_],
	valor(bebida,Casa,leite).
regra(9,Configuracao) :-	% O noruegues vive na primeira casa
	Configuracao = [Casa,_,_,_,_],
	valor(nacionalidade,Casa,noruegues).
regra(10,Configuracao) :-	% O homem que fuma Blends vive ao lado do que tem gatos
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(cigarro,CasaX,blends),
	valor(animal,CasaY,gatos).
regra(10,Configuracao) :-
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(cigarro,CasaY,blends),
	valor(animal,CasaX,gatos).
regra(11,Configuracao) :-	% O homem que cria cavalos vive ao lado de quem fuma Dunhill
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(animal,CasaX,cavalos),
	valor(cigarro,CasaY,dunhill).
regra(11,Configuracao) :-
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(animal,CasaY,cavalos),
	valor(cigarro,CasaX,dunhill).
regra(12,Configuracao) :-	% O homem que fuma Bluemaster bebe cerveja
	member(Casa,Configuracao),
	valor(cigarro,Casa,bluemaster),
	valor(bebida,Casa,cerveja).
regra(13,Configuracao) :-	% O alemao fuma Prince
	member(Casa,Configuracao),
	valor(nacionalidade,Casa,alemao),
	valor(cigarro,Casa,prince).
regra(14,Configuracao) :-	% O noruegues vive ao lado da casa azul
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(nacionalidade,CasaX,noruegues),
	valor(cor,CasaY,azul).
regra(14,Configuracao) :-
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(nacionalidade,CasaY,noruegues),
	valor(cor,CasaX,azul).
regra(15,Configuracao) :-	% O homem que fuma Blends eh vizinho do que bebe agua
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(cigarro,CasaX,blends),
	valor(bebida,CasaY,agua).
regra(15,Configuracao) :-
	append(_,[CasaX,CasaY|_],Configuracao),
	valor(cigarro,CasaY,blends),
	valor(bebida,CasaX,agua).

configuracao_correta(Configuracao) :-
	configuracao(Configuracao),
	regra( 1,Configuracao),
	regra( 2,Configuracao),
	regra( 3,Configuracao),
	regra( 4,Configuracao),
	regra( 5,Configuracao),
	regra( 6,Configuracao),
	regra( 7,Configuracao),
	regra( 8,Configuracao),
	regra( 9,Configuracao),
	regra(10,Configuracao),
	regra(11,Configuracao),
	regra(12,Configuracao),
	regra(13,Configuracao),
	regra(14,Configuracao),
	regra(15,Configuracao).

solucao :- % Quem cria peixes como animal de estimacao?
	configuracao_correta(Configuracao),
	valor(animal,Casa,peixes),
	valor(nacionalidade,Casa,Nacionalidade),
	valor(cor,Casa,Cor),
	member(Casa,Configuracao,Posicao_da_casa),
	member(Posicao,[primeira,segunda,terceira,quarta,quinta],Posicao_da_casa),
	nl,
	write('Quem cria peixes eh o '),
	write(Nacionalidade),
	write(', que mora na '),
	write(Posicao),
	write(' casa ('),
	write(Cor),
	write(').'),
	nl,
	nl,
	write('A configuracao completa eh a seguinte:'),
	nl,
	nl, 
	imprime_configuracao(Configuracao),
	nl.

imprime_configuracao(X) :-
	imprime_configuracao(1,X).	

imprime_configuracao(_,[]).
imprime_configuracao(N,[X|R]) :-
	write('   casa '),
	write(N),
	write(': '),
	imprime_casa(X),
	M is N + 1,
	imprime_configuracao(M,R).

imprime_casa([]) :-
	nl.
imprime_casa([X|R]) :-
	write(X),
	write(', '),
	imprime_casa(R).
